clear all; 
close all;

x = (0:0.02:1);
y = (0:0.02:1);
[X,Y] = meshgrid(x,y);
nt = 50;
dt = 0.05;
N = 25;
c = colormap('jet');
s = surf('cDataMapping','direct','cData',c);
axis([0 1 0 1 0 100]);
title('Chladnut desky');
xlabel('Deska');
ylabel('Deska');
zlabel('Teplota []');


% asov smyka
for j = 1:nt
  u = zeros(length(x),length(y));
  % Dvojit suma
  for m = 1:N % index on x
    for n = 1:N % index on y
      Bmn = 1600 / (pi^2*(2*m-1)*(2*n-1));
      u = u + Bmn * sin((2*m-1)*pi*X) .* sin((2*n-1)*pi*Y) *...
          exp(-( (2*m-1)^2 + (2*n-1) ) * (j*dt));
    end
  end
  set(s,'xdata',x,'ydata',y,'zdata',u)
  drawnow
end
